import "./style.css";
import { defineComponent as Z, computed as k, resolveComponent as T, createElementBlock as A, openBlock as b, Fragment as J, renderList as ee, withDirectives as te, normalizeClass as R, unref as g, createElementVNode as O, normalizeStyle as ne, createCommentVNode as B, createBlock as Y, withModifiers as ae, renderSlot as oe, mergeProps as re, vShow as se, ref as Q, reactive as V, provide as ie, onActivated as ce, onDeactivated as le, watch as de, onMounted as ue, onBeforeUnmount as ge, withCtx as X, createVNode as U, toDisplayString as pe } from "vue";
import { PluginPanel as fe } from "@opentiny/tiny-engine-common";
import { constants as me } from "@opentiny/tiny-engine-utils";
import { useCanvas as m, useMaterial as he, useLayout as $, getMergeMeta as ve, useMessage as be, useHistory as ye } from "@opentiny/tiny-engine-meta-register";
import { extend as De } from "@opentiny/vue-renderless/common/object";
const Ce = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], Se = {
  key: 0,
  class: "expand-icon"
}, _e = /* @__PURE__ */ Z({
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    actives: {
      type: Array,
      default: () => []
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(p, { emit: h }) {
    const r = p, s = k(() => r.actives.length === 0 && r.active ? [r.active] : r.actives), v = (e) => {
      const { idKey: t, labelKey: a, childrenKey: o } = r, i = e[t], f = e[a], u = e[o], l = { id: i, label: f, rawData: e };
      return Array.isArray(u) && (l.children = u.map((N) => v(N))), l;
    }, I = (e) => Array.isArray(e) ? e.map((t) => v(t)) : [], y = k(() => I(r.data)), w = () => {
      const e = Q({});
      return { collapseMap: e, setCollapse: (o, i) => {
        e.value[o] = i;
      }, switchCollapse: (o) => {
        e.value[o] = !e.value[o];
      } };
    }, { collapseMap: D, setCollapse: d, switchCollapse: x } = w(), C = (e, t, a = 0, o = !1) => {
      const { children: i, ...f } = e, u = (i || []).map((N) => C(N, e.id, a + 1, o || D.value[e.id])).flat(), l = {
        ...f,
        parentId: t,
        level: a,
        hasChildren: (i == null ? void 0 : i.length) > 0,
        collapsed: o
      };
      return u.forEach((N) => {
        N.parent || (N.parent = l);
      }), [l].concat(u);
    }, S = (e) => C({ children: e }, null, -1).slice(1), E = k(() => S(y.value)), M = h, K = (e, t) => {
      M("click", e, t);
    }, L = (e) => {
      M("mouseenter", e);
    }, z = () => {
      const e = { dragged: null, hovering: null, position: "", borderClass: "", forbidInsert: !1 }, t = V({ ...e });
      return { draggingState: t, resetDraggingState: () => {
        Object.assign(t, e);
      } };
    }, { draggingState: c, resetDraggingState: j } = z(), F = (e, t) => {
      r.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), c.dragged = t, t.hasChildren && d(t.id, !0));
    }, G = (e) => {
      const t = e.currentTarget.getBoundingClientRect(), a = e.clientY - t.top, o = 8;
      return a <= o ? { position: "top", borderClass: "border-top" } : a >= t.height - o ? { position: "bottom", borderClass: "border-bottom" } : { position: "center", borderClass: "border-all" };
    }, P = (e, t) => {
      if (!r.draggable)
        return;
      const a = G(e);
      if (t.id === E.value[0].id && a.position !== "center") {
        e.preventDefault();
        return;
      }
      if (r.disallowDrop({ dragged: c.dragged, target: t, position: a.position })) {
        Object.assign(c, { ...a, hovering: t, forbidInsert: !0 });
        return;
      }
      e.preventDefault(), Object.assign(c, { ...a, hovering: t, forbidInsert: !1 });
    }, _ = () => {
      if (!r.draggable || c.forbidInsert)
        return;
      const { dragged: e, hovering: t, position: a } = c;
      M("drop", { dragged: e, target: t, position: a });
    }, H = () => {
      j();
    }, n = (e) => {
      if (!r.draggable)
        return;
      const t = e.currentTarget.getBoundingClientRect(), a = 4;
      (e.clientX <= t.left + a || e.clientX >= t.right - a || e.clientY <= t.top + a || e.clientY >= t.bottom - a) && Object.assign(c, { hovering: null });
    };
    return (e, t) => {
      const a = T("svg-icon");
      return b(), A("div", {
        class: "draggable-tree",
        onDragleave: n
      }, [
        (b(!0), A(J, null, ee(E.value, (o) => {
          var i, f, u;
          return te((b(), A("div", {
            key: o.id,
            class: R([
              "tree-row",
              "flex-center",
              {
                active: s.value.includes(o.id),
                dragging: ((i = g(c).hovering) == null ? void 0 : i.id) === o.id,
                "border-all": ((f = g(c).hovering) == null ? void 0 : f.id) === o.id && g(c).position === "center",
                forbid: g(c).forbidInsert
              }
            ]),
            draggable: p.draggable ? "true" : void 0,
            onClick: (l) => K(l, o),
            onMouseenter: (l) => L(o),
            onDragstart: (l) => F(l, o),
            onDragover: (l) => P(l, o),
            onDragenter: (l) => P(l, o),
            onDrop: _,
            onDragend: H
          }, [
            O("div", {
              class: "content flex-center",
              style: ne({ paddingLeft: `${12 * o.level}px` })
            }, [
              o.hasChildren ? B("", !0) : (b(), A("span", Se)),
              o.hasChildren ? (b(), Y(a, {
                key: 1,
                name: "dropdown",
                class: R(["expand-icon", { rotate: g(D)[o.id] }]),
                onClick: ae((l) => g(x)(o.id), ["stop"])
              }, null, 8, ["class", "onClick"])) : B("", !0),
              O("div", {
                class: R([
                  "slot-content",
                  "flex-center",
                  {
                    [g(c).borderClass]: ((u = g(c).hovering) == null ? void 0 : u.id) === o.id && g(c).position !== "center",
                    forbid: g(c).forbidInsert
                  }
                ])
              }, [
                oe(e.$slots, "content", re({ ref_for: !0 }, o), void 0, !0)
              ], 2)
            ], 4)
          ], 42, Ce)), [
            [se, !o.collapsed]
          ]);
        }), 128))
      ], 32);
    };
  }
}), W = (p, h) => {
  const r = p.__vccOpts || p;
  for (const [s, v] of h)
    r[s] = v;
  return r;
}, Ne = /* @__PURE__ */ W(_e, [["__scopeId", "data-v-33e270e9"]]), { PAGE_STATUS: q } = me, ke = {
  components: {
    PluginPanel: fe,
    DraggableTree: Ne
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(p, { emit: h }) {
    const { pageState: r } = m(), { getMaterial: s } = he(), { PLUGIN_NAME: v } = $(), I = k(() => {
      var n;
      return (n = p.fixedPanels) == null ? void 0 : n.includes(v.OutlineTree);
    }), { useSelectNode: y, registerHotkeyEvent: w, removeHotkeyEvent: D } = ve("engine.canvas.container").api, d = k(() => y().selectState.value.map((n) => n.node.id)), x = V({
      emitEvent: h
    });
    ie("panelState", x);
    const C = (n) => {
      const e = (t) => (t.forEach((a) => {
        a.show = r.nodesStatus[a.id] !== !1, a.showEye = !a.show;
        const o = a.children;
        Array.isArray(o) && e(a.children);
      }), t);
      return [{ ...e([De(!0, {}, n)])[0], componentName: "body", id: "body" }];
    }, S = V({
      pageSchema: [],
      isLock: k(
        () => ![q.Occupy, q.Guest].includes($().layoutState.pageStatus.state)
      )
    }), { subscribe: E, unsubscribe: M } = be();
    ce(() => {
      S.pageSchema = C(r.pageSchema), E({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: n }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (S.pageSchema = C(r.pageSchema));
        }
      });
    }), le(() => {
      M({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), de(
      () => r.currentSchema,
      () => {
        const { getSchema: n } = m();
        S.pageSchema = C(n());
      }
    );
    const K = (n) => r.nodesStatus[n] !== !1, L = (n) => {
      n.show = !n.show, r.nodesStatus[n.id] = n.show;
      const { getRenderer: e, clearSelect: t } = m().canvasApi.value;
      e().setCondition(n.id, n.show), t();
    }, z = (n) => {
      const { clearSelect: e } = m().canvasApi.value;
      m().operateNode({
        type: "delete",
        id: n.id
      }), e(), ye().addHistory();
    }, c = (n) => {
      const { hoverNode: e } = m().canvasApi.value;
      e(n.id);
    }, j = ({ dragged: n, target: e, position: t }) => {
      if (n.id === "body")
        return !0;
      const a = t === "center" ? e : e.parent;
      if (a.id === "body")
        return !1;
      const { getConfigure: o, allowInsert: i } = m().canvasApi.value;
      return !i(o(a.rawData.componentName), n.rawData);
    }, F = ({ dragged: n, target: e, position: t }) => {
      if (n.id === e.id || t === "center" && e.rawData.children.some((i) => i.id === n.id))
        return;
      if (t !== "center") {
        const i = e.parent.rawData.children, f = i.findIndex((l) => l.id === e.id), u = i[t === "top" ? f - 1 : f + 1];
        if (n.id === (u == null ? void 0 : u.id))
          return;
      }
      const { insertNode: a, removeNode: o } = m().canvasApi.value;
      o(n.id), a(
        { data: n.rawData, node: e.rawData, parent: e.parent.rawData },
        t === "center" ? "in" : t
      );
    }, G = (n, e) => {
      const t = n.ctrlKey || n.metaKey, { selectNode: a } = m().canvasApi.value;
      a(e.id, "clickTree", t);
    }, P = (n) => (s(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(), _ = Q(null), H = () => _.value.$el.contains(document.activeElement);
    return ue(() => {
      _.value && w(document, { eventFilter: H });
    }), ge(() => {
      _.value && D(document);
    }), {
      panelFixed: I,
      selectedIds: d,
      panelRef: _,
      eyeOpen: K,
      delNode: z,
      showNode: L,
      state: S,
      PLUGIN_NAME: v,
      pageState: r,
      getIconName: P,
      handleClickRow: G,
      handleMouseEnterRow: c,
      disallowDrop: j,
      handleDrop: F
    };
  }
}, we = { class: "row-content" };
function xe(p, h, r, s, v, I) {
  const y = T("svg-icon"), w = T("draggable-tree"), D = T("plugin-panel");
  return b(), Y(D, {
    tabindex: "0",
    title: "大纲树",
    ref: "panelRef",
    class: "outlinebox plugin-tree",
    "fixed-name": s.PLUGIN_NAME.OutlineTree,
    fixedPanels: r.fixedPanels,
    onClose: h[0] || (h[0] = (d) => p.$emit("close"))
  }, {
    content: X(() => [
      U(w, {
        "label-key": "componentName",
        data: s.state.pageSchema,
        draggable: !0,
        actives: s.selectedIds,
        "disallow-drop": s.disallowDrop,
        class: "outline-tree",
        onClick: s.handleClickRow,
        onMouseenter: s.handleMouseEnterRow,
        onDrop: s.handleDrop
      }, {
        content: X((d) => [
          O("div", we, [
            s.getIconName(d) ? (b(), Y(y, {
              key: 0,
              name: s.getIconName(d)
            }, null, 8, ["name"])) : B("", !0),
            O("span", {
              class: R(["row-label", { "node-isblock": d.rawData.componentType === "Block" }])
            }, pe(d.label), 3),
            d.id !== "body" ? (b(), A(J, { key: 1 }, [
              U(y, {
                name: s.eyeOpen(d.id) ? "eye" : "eye-invisible",
                onMouseup: (x) => s.showNode(d.rawData)
              }, null, 8, ["name", "onMouseup"]),
              U(y, {
                name: "delete",
                onMouseup: (x) => s.delNode(d.rawData)
              }, null, 8, ["onMouseup"])
            ], 64)) : B("", !0)
          ])
        ]),
        _: 1
      }, 8, ["data", "actives", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels"]);
}
const Me = /* @__PURE__ */ W(ke, [["render", xe], ["__scopeId", "data-v-c073c4a5"]]), Ae = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  widthResizable: !0,
  align: "leftTop"
}, Be = {
  ...Ae,
  entry: Me
};
export {
  Be as default
};
